/* @C:\web_509\SQL\end_conv\oracle\4202_GOPTRGO_LOG_FILIALOPEROP.sql
   Trigger criada para gerar log das transaes na tabela FILIALOPEROP */
CREATE OR REPLACE TRIGGER LOG_FILIALOPEROP
AFTER DELETE OR INSERT OR UPDATE
ON FILIALOPEROP FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' Filial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.CDGRUPGERENTEOP IS NOT NULL THEN
         V_DESC := V_DESC || ' Gerente=' || :OLD.CDGRUPGERENTEOP;
      END IF;

      IF :OLD.CDOPERADOR IS NOT NULL THEN
         V_DESC := V_DESC || ' Operador=' || :OLD.CDOPERADOR;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL||';'||:OLD.CDGRUPGERENTEOP||';'||:OLD.CDOPERADOR;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.IDACESSOCALC    <> :NEW.IDACESSOCALC) OR
            (:OLD.IDACESSOAPROV   <> :NEW.IDACESSOAPROV)   THEN

            IF (:OLD.IDACESSOCALC    <> :NEW.IDACESSOCALC) THEN
               V_DESC := V_DESC || ' IDACESSOCALC=' ||:NEW.IDACESSOCALC;
            END IF;

            IF (:OLD.IDACESSOAPROV    <> :NEW.IDACESSOAPROV) THEN
               V_DESC := V_DESC || ' IDACESSOAPROV=' ||:NEW.IDACESSOAPROV;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDFILIAL||';'||:OLD.CDGRUPGERENTEOP||';'||:OLD.CDOPERADOR;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||';'||:NEW.CDGRUPGERENTEOP||';'||:NEW.CDOPERADOR;
         V_CDFILLOGOPER := :NEW.CDFILIAL;

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || ' Filial=' || :NEW.CDFILIAL;
         END IF;

         IF :NEW.CDGRUPGERENTEOP IS NOT NULL THEN
            V_DESC := V_DESC || ' Gerente=' || :NEW.CDGRUPGERENTEOP;
         END IF;

         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || ' Operador=' || :NEW.CDOPERADOR;
         END IF;

      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('FILIALOPEROP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FILIALOPEROP','5.09.000'); END;
/
